

#include "quaternion.h"
#include "../math/random.h" 

void test_quaternion( )
{
   linalg::quaternion q1 = linalg::quaternion( 44, 1.0, 2.0, 3.5 );
   linalg::quaternion q2 = linalg::quaternion( 0, 20, 12, -2);

   std::cout << q1 << "\n";
   std::cout << q2 << "\n";

   std::cout << "rot: " << ( q1 * q2 ) / q1 << "\n";
   std::cout << "rotfrommatrix: " << 
          q1. getrotationmatrix( ) * q2. getvector( ) << "\n";

   linalg::vector vv = 
          dotproduct( q1. getvector( ), q2. getvector( )) * 
                q1. getvector( );
   vv += q1.r * q1.r * q2. getvector( );
   vv += 2.0 * q1.r * 
             crossproduct( q1. getvector( ), q2. getvector( ));

   vv -= crossproduct( crossproduct( q1. getvector( ), q2. getvector( )), 
                       q1. getvector( ));

   std::cout << "result of form: " << vv / q1. norm( ) << "\n";

   // Does x = ( e.x ).e + ( e X x ) X e hold?
   // Yes, it holds when e has unit length.

   linalg::vector e = linalg::vector( 0.5, 2.3, -1.77 );
   e /= e. length( );

   vv = linalg::vector( 3,2,1);

   std::cout << e << "\n";
   std::cout << vv << "\n"; 
   std::cout << "another form: " <<  dotproduct( e, vv ) * e +
                 crossproduct( crossproduct( e, vv ), e ) << "\n"; 

   // Decomposition:
  
   linalg::vector vx = crossproduct( crossproduct( e, vv ), e );
   linalg::vector vz = dotproduct( e, vv ) * e;
   linalg::vector vy = crossproduct( e, vv );
 
   std::cout << "vx = " << vx << "\n";
   std::cout << "vy = " << vy << "\n"; 
   std::cout << "vz = " << vz << "\n";

   double phi = 0.05;
   linalg::vector rot = vz + vx * cos( phi ) + vy * sin( phi ); 
   std::cout << rot << "\n"; 

   linalg::quaternion qr = linalg::quaternion::rotation( e * 0.05 );
   std::cout << qr. getrotationmatrix( ) * vv << "\n";

   std::cout << "\n"; 
   std::cout << ( q2 * q1 ). getrotationmatrix( ) << "\n";
   std::cout << ( q2. getrotationmatrix( )) * 
                ( q1. getrotationmatrix( ))  << "\n";
}


