
#ifndef MATH_HALF_ATAN_DEFINED
#define MATH_HALF_ATAN_DEFINED 1

#include <utility>

namespace math
{
   std::pair< double, double > half_atan( double x, double y );
      // Returns a pair ( p, q ) s.t. the matrix
      //    / p  -q \   squared equals   / x  -y \
      //    \ q   p /                    \ y   x /
      // 
      // We have atan2( q, p ) = 0.5 * atan( y, x ).

}

#endif

