

#include "random.h"
#include "../linalg/vector.h"
#include <cstdlib>
#include <stdexcept> 


unsigned int math::random::randomunsigned( unsigned int upperbound )
{
   if( upperbound < 2 )
      std::logic_error( "upperbound must be 2 at least" ); 

   int r = rand( );
   return r % upperbound;
}


double math::random::randomdouble( ) 
{
   int r = rand( );
   r = r % 1000000;
   return r / 1000000.0;
}


linalg::vector math::random::randominunitcube( )
{
   int r = rand( );
   unsigned int x = ( r & 0XFF );
   unsigned int y = ( r >> 8 )  & 0XFF;
   unsigned int z = ( r >> 16 ) & 0XFF;

   return linalg::vector( x / 128.0 - 1.0,
                          y / 128.0 - 1.0,
                          z / 128.0 - 1.0 );
}


linalg::vector math::random::randominunitsphere( )
{
   linalg::vector v = randominunitcube( );
   while( v. norm( ) > 1.0 )
      v = randominunitcube( );
   return v;
}


linalg::vector math::random::randominunitcircle( )
{
   linalg::vector v = randominunitcube( );
   v. z = 0.0;
   while( v. norm( ) > 1.0 )
   {
      v = randominunitcube( );
      v. z = 0.0;
   }
   return v;
}


