
// Written by Hans de Nivelle, January 2017.
// state_acc is the derivative of state.

#ifndef PHYSICS_STATE_ACC_INCLUDED
#define PHYSICS_STATE_ACC_INCLUDED  1

#include <iostream>
#include "../linalg/vector.h"

namespace physics
{
   struct state_acc
   {
      linalg::vector acc;    // Linear acceleration in external coordinates.
      linalg::vector alpha;  // Angular acceleration in external coordinates.

      state_acc( const linalg::vector& acc, const linalg::vector& alpha )
         : acc{ acc }, alpha{ alpha }
      { }

   };


   inline std::ostream& operator << ( std::ostream& out, const state_acc& a )
   {
      out << "d(State)/dt:\n";
      out << "   a (linear)      :        " << a. acc << "\n";
      out << "   alpha (angular) :        " << a. alpha << "\n";
      return out;
   }
}

#endif


